#include "BuiltIns.h"

// camera initialization array - this is an array of CameraInitializationData
// records. The 
unsigned char numberOfCameraInitBlocks = 1;
CameraInitializationData cameraData[] =
{
	{ 85,115,15,17,100,145,0,1,0,1,0,0,128,128,128,1,16,8,5,30,15,5 }
};

/*
 * this function limits value in the to "limit" in magnitude. If it is less
 * than -limit, the value is -limit. If it is more than limit, the value is
 * limit.
 */
int limit(int value, int limit)
{
	if (value > limit) return limit;
	if (value < -limit) return -limit;
	return value;
}


/*
 * Camera test program -
 * Drives in circles until the camera sees the green target, then it drives towards
 * the target. This assumse that the camera is mounted in the front of the robot
 * without the servos connected. They are not used for this example.
 */
void main(void)
{
	TPacket *tp;
	unsigned char mx, my;
	unsigned char conf;
	int error;
	unsigned long time;
	
	TwoWheelDrive(2, 1);
	
	InitCamera(1);				// initialize the camera for the green target
	StartCamera();				// start the camera tracking

	// this program spins the robot around in a circle until it sees
	// the color target then drives towards it.	
	while (1)
	{
		// look for the target
		tp = CopyTrackingData();	// get the most recent camera data
		conf = tp->confidence;		// get the confidence
		if (conf > 10) break;		// break out of this loop if the target seen
		Drive(0, 50);				// drive in circles
		Wait(100);					// wait a while
	}

	while (1)
	{
		// drive towards target
		tp = CopyTrackingData();	// get some camera data
		error = limit(4 * (((int)tp->mx) - 80), 55);	// limit the x value
		if (tp->confidence > 0)		// only drive when we see something
			Drive(70, error);		// drive towards the target
		else
			Drive(0, 0);			// don't drive when not seeing target
	}
}
